<template>
    <div>
        <el-form :inline="true" :model="query" class="query-form" size="mini">
            <el-row>
                <el-form-item class="query-form-item">
                    <el-input v-model="filterQuery.genKey" placeholder="记录ID"></el-input>
                </el-form-item>

                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.status" placeholder="处理状态">
                        <el-option label="全部" value=""></el-option>
                        <el-option label="处理中" value="0"></el-option>
                        <el-option label="已处理" value="1"></el-option>
                        <el-option label="异常" value="2"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button-group style="display:flex;">
                        <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                        <el-button type="primary" icon="search" @click="getList">查询</el-button>
                        <el-button type="primary" icon="search" @click="dlSmp">下载器械信息</el-button>

                    </el-button-group>
                </el-form-item>
            </el-row>
        </el-form>

        <el-table
            v-loading="loading"
            :data="list"
            style="width: 100%"
            @selection-change="handleSelectionChange"
        >
            <el-table-column label="序号" type="index"></el-table-column>
            <el-table-column
                label="记录ID"
                prop="genKey"
                show-overflow-tooltip
            ></el-table-column>

            <el-table-column
                label="来源"
                prop="fromType"
                show-overflow-tooltip
            >
            </el-table-column>
            <el-table-column
                label="更新日期"
                prop="updateTime"
                show-overflow-tooltip
            ></el-table-column>
            <!--<el-table-column-->
            <!--label="来源系统"-->
            <!--prop="thirdSysFk"-->
            <!--show-overflow-tooltip-->
            <!--&gt;</el-table-column>-->
            <el-table-column
                label="状态"
                prop="status"
                show-overflow-tooltip
            >
                <template slot-scope="scope">
                    <el-tag
                        :type="statusFilterType(scope.row.status)"
                    >{{ status[scope.row.status] }}
                    </el-tag
                    >
                </template>
            </el-table-column>
            <el-table-column label="操作" fixed="right" width="160">
                <template slot-scope="scope">
                    <el-button
                        type="text"
                        size="small"
                        @click.native.stop="handleDetailClick(scope.row)"
                    >详情
                    </el-button
                    >
                    <el-button
                        type="text"
                        size="small"
                        @click.native.stop="deleteDialog(scope.row.id)"
                    >删除
                    </el-button
                    >
                </template>
            </el-table-column>
        </el-table>


        <el-dialog
            title="器械信息导入详情"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :visible.sync="udiImportDetailVisible"
            width="85%"
            v-if="udiImportDetailVisible"
        >
            <udiInfoImportDetail :currentRow="currentRow" :closeDialog="cancelDialog"></udiInfoImportDetail>
        </el-dialog>

        <el-pagination
            :page-size="filterQuery.limit"
            @current-change="handleCurrentChange"
            layout="prev, pager, next"
            :total="total"
            :current-page="filterQuery.page"
        ></el-pagination>
    </div>
</template>

<script>
import axios from "axios";
import {filterDetail, filterLog, deleteLog, downloadSmp} from "../../api/basic/udiinfolog";
import {getBasicThirdSys} from "../../api/basic/basicThirdSys";
import udiInfoImportDetail from "./UdiInfoImportDetail";

export default {
    data() {
        return {
            filterQuery: {
                genKey: null,
                status: null,
                fromType: "供应商平台下载",
                page: 1,
                limit: 20,
                thirdSysFk: null,
            },
            udiImportDetailVisible: false,
            checked: false,
            lastData: null,
            list: [],
            detailList: [],
            thirdSys: [],
            thirdSysDetail: null,
            total: 0,
            currentRow: null,
            editQuery: null,
            fromStatus: {
                0: "产品信息",
                1: "库存信息",
                2: "异常第三方上传"
            },
            status: {
                0: "等待处理",
                1: "正在处理",
                2: "处理异常",
                3: "处理完成"
            },
            uploadFileUrl: null,
            uploadData: {
                thirdSys: "thirdId",
            },
            templateDlUrl: null,
        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                fromType: "供应商平台下载",
                genKey: null,
                status: null,
                page: 1,
                limit: 20,
                thirdSysFk: null,
            };
            this.getList();
        },
        getList() {
            this.loading = true;
            filterLog(this.filterQuery)
                .then((response) => {
                    this.loading = false;
                    this.list = response.data.list || [];
                    this.total = response.data.total || 0;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },


        getLastOne() {
            let query = {
                fromType: "供应商平台下载",
                page: 1,
                limit: 1,
            };
            filterLog(query)
                .then((response) => {
                    this.loading = false;
                    this.lastData = response.data.list[0];
                })
                .catch(() => {
                    this.loading = false;
                });
        },

        genInCode() {
            this.selectBasicUdiVisible = true;
        },
        handleDetailClick(row) {
            this.currentRow = row;
            console.log(this.currentRow.genKey)
            this.udiImportDetailVisible = true;

        },
        cancelDialog() {
            this.udiImportDetailVisible = false;
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },
        deleteDialog(rowId) {
            this.$confirm("此操作将删除该产品信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    let dQuery = {
                        id: rowId,
                    };
                    deleteLog(dQuery)
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                            } else {
                                this.$message.error(response.message);
                            }
                            this.getList();
                        })
                        .catch(() => {
                            this.loading = false;
                        });
                })
                .catch(() => {
                });
        },
        getBasicThirdSys() {
            let query = {
                enabled: true,
            };
            getBasicThirdSys(query)
                .then((response) => {
                    this.thirdSys = response.data.list || [];
                    // this.filterQuery.thirdSysFk = this.thirdSys[0].thirdId;
                    this.getList();
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });
            axios.get("./config.json").then(res => {
                let response = res.data.BASE_URL;
                this.uploadFileUrl = response + "/udiwms/products/importLog/upload";
            });
            axios.get("./config.json").then(res => {
                let response = res.data.SERVER_IP;
                this.templateDlUrl = response + "/已对照产品信息模板.xlsx";
            });
        },
        jumpDl() {
            window.open(this.templateDlUrl, '_blank');
        },
        handleChange(response, files, fileList) {
            console.log(response);
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                // console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                this.getList();
                this.$message.success("文件上传成功,请稍后刷新查看！");
            }
        },
        statusFilterType(status) {
            const statusMap = {
                0: "warning",
                1: "warning",
                2: "danger",
                3: "success",
            };
            return statusMap[status];
        },
        dlSmp() {


            let query = {
                fromType: "供应商平台下载",
                status:3,
                page: 1,
                limit: 1,
            };
            filterLog(query)
                .then((response) => {
                    this.loading = false;
                    let lastData = response.data.list[0];
                    let tip = null;
                    if (lastData == null) {
                        tip = "此操作将下载所有全部器械信息, 是否继续?"
                    } else {
                        tip = "上次成功更新时间是" + lastData.updateTime + " , 是否继续?"
                    }
                    this.$confirm(tip, "提示", {
                        confirmButtonText: "确定",
                        cancelButtonText: "取消",
                        type: "warning",
                    })
                        .then(() => {
                            this.loading = true;
                            let tquery = {
                                lastUpdateTime: null
                            };
                            if (lastData!= null)
                                tquery.lastUpdateTime = lastData.updateTime;

                            downloadSmp(tquery)
                                .then((response) => {
                                    this.loading = false;
                                    this.$message.success(response.data);
                                    this.getList();
                                })
                                .catch(() => {
                                    this.loading = false;
                                });
                        })
                        .catch(() => {
                        });


                })
                .catch(() => {
                });


        }
    },
    mounted() {
    },
    components: {udiInfoImportDetail},
    created() {
        this.getBasicThirdSys();
        this.getList();
    },
};
</script>
<style>
.itemTag {
    float: left;
    text-align: left;
    margin-top: 10px;
    width: 100px;
}

.text {
    font-size: 13px;
    font-family: "Microsoft YaHei";
}

.el-row {
    display: flex;
    flex-wrap: wrap;

}

.el-col {
    border-radius: 4px;
    flex-wrap: wrap;
}
</style>
